
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>WinCE6.0中应用程序如何直接访问物理空间 / iVAN</title>

    <meta name="description" content="WinCE6.0中应用程序如何直接访问物理空间    在实际开发过程中,经常希望能在应用程序中直接读写设备的物理空间.以前在做WinCE6.0下的MEMMgr时通过秘密加载一个内核态驱动实现了这个需求.但这种方式有一个明显的缺陷,每次读写都必须经由它才能完成.如果只是读取GPIO,那问题不算大.如果想通过这种方式实现视频播放的加速就比较困难了.估计非但不能加速,反而会变得更慢.      早先曾与ZL仔细的讨论过这个问题,他当时在WinCE6.0上移植TCPMP,发现播放视频不太流畅,于是想通过直接写显存进行加速.目的很明确,在应用中申请一段">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">WinCE6.0中应用程序如何直接访问物理空间</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>   在实际开发过程中，经常希望能在应用程序中直接读写设备的物理空间。以前在做WinCE6.0下的MEMMgr时通过秘密加载一个内核态驱动实现了这个需求。但这种方式有一个明显的缺陷，每次读写都必须经由它才能完成。如果只是读取GPIO，那问题不算大。如果想通过这种方式实现视频播放的加速就比较困难了。估计非但不能加速，反而会变得更慢。<br />      早先曾与ZL仔细的讨论过这个问题，他当时在WinCE6.0上移植TCPMP，发现播放视频不太流畅，于是想通过直接写显存进行加速。目的很明确，在应用中申请一段虚拟空间，通过某种方法将其映射到显存上，视频解码过程中直接往映射过的虚拟空间上写。这种方法与使用GAPI有一点类似。</p>
<p>      实现这个需求，需要用到函数VirtualCopyEx()。看看帮助中关于它的说明，This function dynamically maps a virtual address to a physical address by creating a new page-table entry.This function is callable in kernel mode and in user mode, when the source and destination process handles are the active process.This function is similar to <strong>VirtualCopy</strong>, except <strong>VirtualCopyEx</strong> requires handles to the source and destination process.</p>
<p>      据此基本可以确定，我们的确可以在应用中申请一段虚拟空间，然后通过这个函数将其映射到某段物理空间上。其中目标进程是我们的应用，而源进程是NK.exe。为了实现在NK.exe中执行VirtualCopyEx()，可以加载一个内核态的驱动。更为方便的方法是移植一个OALIOCTL，并在IOControl()中添加一个case。这样，应用程序在做内存映射时就无需打开某个流驱动，直接调用KernelIoControl()即可。</p>
<p>      OALIOCTL中添加的关键代码如下。 </p>
<pre>1 typedef struct {
 2     void*    pvDestMem;
 3     DWORD    dwPhysAddr;
 4     DWORD    dwSize;
 5 } VIRTUAL_COPY_EX_DATA;
 6
 7 #define IOCTL_VIRTUAL_COPY_EX CTL_CODE (FILE_DEVICE_UNKNOWN,3333,METHOD_BUFFERED,FILE_ANY_ACCESS)
 8
 9
10 case IOCTL_VIRTUAL_COPY_EX:
11 {
12     VIRTUAL_COPY_EX_DATA *p = (VIRTUAL_COPY_EX_DATA*)pInBuf;
13     HANDLE hDst = (HANDLE)GetDirectCallerProcessId();
14     HANDLE hSrc = (HANDLE)GetCurrentProcessId();
15     fRet = VirtualCopyEx(hDst,p-&gt;pvDestMem,hSrc,(LPVOID)p-&gt;dwPhysAddr,p-&gt;dwSize,
16 　　　　 PAGE_READWRITE|PAGE_PHYSICAL|PAGE_NOCACHE);
17 }break;</pre>
<p>      应用程序中进行内存映射的关键代码如下。</p>
<pre> 1 volatile LPVOID GetVirtual(DWORD dwPhyBaseAddress, DWORD dwSize)
 2 {
 3     volatile LPVOID pVirtual;
 4     VIRTUAL_COPY_EX_DATA vced;
 5
 6     if(dwPhyBaseAddress&amp;0xFFF)
 7     {
 8         return NULL;
 9     }
10     vced.dwPhysAddr = dwPhyBaseAddress&gt;&gt;8;
11     pVirtual = VirtualAlloc(0,dwSize,MEM_RESERVE,PAGE_NOACCESS);
12     vced.pvDestMem = pVirtual;
13     vced.dwSize = dwSize;
14     KernelIoControl(IOCTL_VIRTUAL_COPY_EX,&amp;vced, sizeof(vced), NULL, NULL, NULL);
15     return pVirtual;
16 }
17
18 // WinCE6.0模拟器中应用程序直接写屏
19 PBYTE pLCDBuf = (PBYTE)GetVirtual(0x33f00000,0x100000);
20 memset(pLCDBuf,0,0x100000);
21 </pre>
<p>这种方法在WinCE6.0的模拟器中测试了一下，能达到预期的效果。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-16 06:00:55</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>, <a href="https://www.iamivan.net/tag/%e5%86%85%e5%ad%98%e6%98%a0%e5%b0%84/" title="内存映射">内存映射</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>WinCE6.0中应用程序如何直接访问物理空间的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pmjBPjz.html" rel="bookmark">WinCE6&period;0中托管代码如何访问物理空间</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				      之前整理过一篇&lt;WinCE6.0中应用程序如何直接访问物理空间&gt;的短文,文中介绍的方法突破了WinCE6.0系统本身的限制,使应用程序能够直接读写指定的内存地址,如访问系统显存.在WinCE中,使用托管代码编写应用程序直接访问物理空间,之前也曾简单介绍过,当时是基于VB.NET实现的,请参考&lt;WinCE下VB.NET程序的开发&gt;.今天再凑一篇基于C#的.       原理之前两篇都已经讲过了,这里不再赘述.实现方法与VB.NET类似,首先用C++编写一个动态链接库,实现			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pX20r5b.html" rel="bookmark">WinCE6&period;0中Romimage&period;exe的BUG</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				     WinCE6.0的Romimage.exe依然存在BUG,跟WinCE5.0一样.当新建的工程和PB的安装目录不在同一分区时就不能正确生成nb0文件.本以为WinCE6.0已经解决这个问题,不想饱汉不知饿汉饥,他们似乎没有发现这个BUG,也就不可能修复了.        好在WinCE6.0开源,在Private的目录下找到了对应的源代码目录,打算修改代码,重新编译一个romimage.exe.看了半天,没找到什么线索,貌似少一些文件.只能另辟蹊径了.        先找蛛丝马迹.在b			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/baml92b.html" rel="bookmark">flash AS 3&period;0中MC创建复制及访问实例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				主要看了MC的创建复制及访问,这个对于在制作和数据库结合的flash网站也是比较重要的一个环节. MC的创建:  代码如下 复制代码 //普通方式创建一个名为mc2的影片剪辑---------------- var mc2:Sprite = new Sprite(); //和C#一样,初始化一个实例 mc2.graphics.beginFill(0xFFCC00); //设置填充色 mc2.graphics.drawCircle(50, 50, 40); //画圆 mc2.buttonMode			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJ2OR4z.html" rel="bookmark">WinCE5&period;0中应用程序如何直接写屏</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				以前曾利用GAPI实现应用程序直接操作显示驱动的FrameBuffer,以提高屏幕绘图和视频播放的效率.GAPI依赖于显示驱动,必须在显示驱动中添加相应的接口才能正常使用.如果平台是我们自己定制的,在WinCE5.0中,我们也可以通过另外一种方法来操作FrameBuffer. 以DeviceEmulator为例,我们已经知道FrameBuffer的物理地址是0x30100000,大小为0x100000.那么在应用程序中可以通过如下代码,直接获取操作FrameBuffer的机会. 代码 1    			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bElRJ6z.html" rel="bookmark">在Asp&period;Net2&period;0中可以方便的访问配置文件web&period;config&comma;如判断debug设置，验证类型</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Asp.Net2.0中我们可以方便的访问配置文件中,.NetFrameWork2.0新增加了 SystemWebSectionGroup 类. 允许用户以编程方式访问配置文件的 system.web 组. 比如判断web.config内是否为 debug=&quot;true&quot;,或者判断身份验证形式 SystemWebSectionGroup ws = new SystemWebSectionGroup(); CompilationSection cp = ws.Compilation; 用cp			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zOlRY8b.html" rel="bookmark">Windows XP下安装WinCE6&period;0开发环境</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Windows下如何编译WinCE6.0及开发应用程序,下面介绍(安装之前必须保证C盘有足够的空间!20g左右!主要是因为在安装程序在安装过程中要解压): 在Visual Studio 2005之前,开发WinCE嵌入式程序需要安装Platform Builder,不过Platform Builder已经作为一个插件集成在Visual Studio 2005里了. 1.下载并安装Visual Studio 2005(Visual Studio 2008只支持开发应用程序,不能用来定制WinCE内			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M9Jxn4p.html" rel="bookmark">WinCE6&period;0的EBOOT概要</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				     为一个新的硬件设备定制WinCE6.0操作系统,一般需要完成以下几个主要步骤: 1.       针对特定的硬件设备创建板级支持包(Board Support Package缩写为BSP),BSP必须包括BOOTLOADER.OEM适配层(OEM Adaptation Layer缩写为OAL)和一些必要的驱动. 2.       利用创建的BSP,定制一个系统设计(OS Design).即通过VS2005创建一个Platform Builder的工程.该工程可编译产生最终的运行时映像文			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bBPgxdp.html" rel="bookmark">WinCE6&period;0 KITL概要</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				KITL(Kernel Independent Transport Layer)即内核独立传输层,它为我们提供了一种调试WinCE的简便方法.KITL将通信服务协议和用于通信的硬件分离开来.所以我们在创建硬件传输层时就省去很多麻烦,否则我们自己必须实现与设备进行数据交互的协议.KITL工作在硬件传输层之上,因此,它无须关心用于通信的具体硬件,我们可以用USB.Serial或者Ethernet作为KITL的调试通道.具体选择哪一个,由硬件平台和软件资源决定.有些设备没有Ethernet和Seria			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M690vNb.html" rel="bookmark">S3C2410 &amp;amp&semi;&amp;amp&semi; WinCE6&period;0的中断处理分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				     S3C2410的内核是ARM920T,所以,这里先介绍一下ARM920T的异常.ARM920T中有一个当前程序状态寄存器(CPSR),其中BIT6和BIT7分别控制FIQ和IRQ的使能与否.大家经常说的开中断和关中断,就是指的设置这两个BIT.        ARM体系的异常中断如下图所示:                        可以看到,ARM920T中一共有7中异常模式,如果同一时刻有多个异常发生,系统则通过优先级顺序来决定处理其中的哪一个异常.他们之间的优先级顺序从高到低			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/rz4meqb.html" rel="bookmark" class="title">如何将 CSS 加诸于网页</a>
					<div>
						css|网页     您可以利用下列 3 种方式,将 CSS 指定的格调加诸于网页上:     1. 在 HTML 档案里加一个超连结,连到外在的 CSS 档     这个方法最方便管理整个网站的网页 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0bo83BM.html" rel="bookmark" class="title">SEO境界提升之从人性化出发</a>
					<div>
						随着每个人做SEO时间的长短,对于SEO的理解是不一样的,比如一个刚踏入这个行的人它认为这是一门很高深的技术.特别是做几个关键词排名失败以后更认为这门技术有多么深不可测,由于每天努力学习,从哪里看到一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMg8l8p.html" rel="bookmark" class="title">彻底剖析C&num; 2&period;0泛型类的创建和使用</a>
					<div>
						创建     &quot;一次编码,多次使用&quot;,这就是引入泛型的根源.在以前的C++中称为模板,C#泛型通过算法和数据结构支持独立编码.例如,泛型列表意味着,你不必再重写一个强类型集合.在本 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJ7kLVb.html" rel="bookmark" class="title">综合布线ANSI&sol;TIA&sol;EIA568-B：6类电缆标准</a>
					<div>
						1 综合布线铜缆双绞线6类线标准 综合布线铜缆双绞线6类线标准已经正式出台.随着计算机技术的飞跃发展,人们对快速通信的需求,对宽带带传输高速率的要求日益提高,作为网络的通信平台--综合布线系统的带宽也 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXBxx5b.html" rel="bookmark" class="title">程序员该如何学习英语</a>
					<div>
						一.程序员对英语能力的重视度和能力要求应该是在各行各业中排在比较靠前的 这样说吧, 英语程度的好坏直接影响着一个程序员的编程.开发.创新能力. 道理很简单: 1. 计 算机和软件是用英语创造出来的 2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxPQ2yM.html" rel="bookmark" class="title">C&plus;&plus;基础教程-数组</a>
					<div>
						数组是指数据在内存中按顺序存放,通过数组名和序号,就可以很方便地查找和使用数据,本教程为大家介绍C++语言中的数组: 1.启动 Geany 1)点菜单&quot;应用程序-编程-Geany&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3N7V3z.html" rel="bookmark" class="title">asp 获取字符串中url地址函数</a>
					<div>
						asp教程 获取字符串中url地址函数 本文章提供了三款利用asp的正则获取字符串中url地址自定义函数哦,三个方法的实现原理都是获取以http开的url地址哦. on error goto z di ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvG5oap.html" rel="bookmark" class="title">不要91 就要豌豆荚</a>
					<div>
						91助手丰富的功能确实方便了很多手机用户,但是这就意味着咱们离开91助手之后就不能轻松享受玩机的乐趣吗?当然不是!至少咱们的Android用户率先找到了自己的归宿--豌豆夹 基础功能到位,下载速度飞快 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmGjelb.html" rel="bookmark" class="title">win7旗舰版扩充硬盘容量需要注意哪些问题</a>
					<div>
						  1.其实只要电脑购买的时间不是很长的话,那么需要扩充的空间就不会很大,也许就差那么几十个G,如果是这样的话,小编建议各位花十几块钱买一个二手的硬盘即可,至于最新的ITB的硬盘这种就没有多大的必要了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJZGmwz.html" rel="bookmark" class="title">Win7系统的几个优化技巧介绍</a>
					<div>
						  1.减少随机启动项 随机启动项,可以直接在&quot;开始菜单&quot;-&gt;&quot;运行&quot;中输入msconfig,在弹出的窗口中切换到Startup标签,禁用掉那些不需要的启 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVwB7nb.html" rel="bookmark" class="title">android-andriod tcp recv window调整算法</a>
					<div>
						问题描述 andriod tcp recv window调整算法 请教关于android下关于tcp通告窗口的调整算法,比如,窗口调整变大,是由于什么导致?					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boRPjgz.html" rel="bookmark" class="title">test-python 进行单元测试的时候出现了一个特别奇怪的问题</a>
					<div>
						问题描述 python 进行单元测试的时候出现了一个特别奇怪的问题 def test_parse_object(): result=parse.parse_object([('noun','bear' ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2PddBp.html" rel="bookmark" class="title">Spring事务&mdash;&mdash;Spring 2&period;X的事务配置策略</a>
					<div>
						Spring 2.X的事务配置策略     虽然前面介绍的TransactionProxyFactoryBean配置策略简单易懂,但配置起来极为麻烦:每个目标Bean都需要配置一个Transactio ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqA6lkM.html" rel="bookmark" class="title">编程-java调用方法的简单问题</a>
					<div>
						问题描述 java调用方法的简单问题 小弟刚刚自学java,在学习时遇到一个编程题,问题是y=x+3(x&gt;0) =0(x=0) =x*x-1(x&gt;0) 这是小弟编的代码, 这是报错 恳请大 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqRaXRp.html" rel="bookmark" class="title">求两个正则表达式，谢谢大神！</a>
					<div>
						问题描述 小弟初学者,求教2个正则表达式.1:textbox控件只允许输入纯数字和小数点,小数点后3位保留.2:同1,但是还允许输入-号,也就是负数.再次谢谢啦. 解决方案 解决方案二:可以在text ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGENr2M.html" rel="bookmark" class="title">语音信息服务Voicegem被Palantir收购</a>
					<div>
						创业孵化机构2012年夏季班初创公司Voicegem宣布,它的团队将加入情报分 析平台Palantir,3月中旬它将关闭自己的语音电子邮件服务.虽然Vociegem已经发送了超过100万秒的语音记录, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zV0ryVM.html" rel="bookmark" class="title">WINDOW程序设计-渐进</a>
					<div>
						自从3月2日下午4:20又几分钟收到这本经典巨作&lt;window程序设计&gt;我就很兴奋,这本书给我的感觉就想&lt;C++Primer Plus&gt;,或者更好,因为它们两者都兼备了一个共同 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1reO5p.html" rel="bookmark" class="title">数据分析总论</a>
					<div>
						总论 近十年以来,所有的各政府单位和各国的企业,纷纷同入大笔的资金和人力来建设内部IT系统及数据库.虽然改善的过程中有很多挫折和失败,但这些努力使得今天大部份的公司和单位都开始有一个完整统一的内部数据 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGEk7kM.html" rel="bookmark" class="title">面对激烈的竞争 网站运营需知已亦需知彼</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 古语有云:知已知彼,方能百战百胜. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boKVBDb.html" rel="bookmark" class="title">Sun公布第四季度初步财报结果</a>
					<div>
						北京时间7月14日晚间消息,据国外媒体报道,Sun今天公布了2009财年第四季度的初步财报结果. 在截至6月30日的这一财季,Sun预计公司营收为25.80亿美元到26.80亿美元,不及去年同期的37 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPBEoZb.html" rel="bookmark" class="title">中小品牌手机厂商的春天来了吗&quest;</a>
					<div>
						近期,中移动召开全球合作伙伴大会.在终端分论坛上,有三件事很巧合的碰到一起: 一是中移动.高通与ODM厂商签署五模公版项目协议,目的是降低产业研发成本,推动五模手机发展,项目主要扶持中小手机厂商.   ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjwPdVM.html" rel="bookmark" class="title">插件-winform程序打包的问题</a>
					<div>
						问题描述 winform程序打包的问题 开发一个winform程序想打包,其中包含了几个第三方插件,在安装时,想给用户一个提示,让用户选择是否要安装插件1,插件2,如果用户勾选上,就安装,否则就不安装 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4e9g1b.html" rel="bookmark" class="title">java实现ISO端的接口中数据的分页</a>
					<div>
						问题描述 java实现ISO端的接口中数据的分页 请问:我现在给ISO端写接口(Java开发),分页上怎样处理?,我现在接口端已经把分页功能实现了,但是需要iOS端给我传一个参数值&quot;page ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4e8RPb.html" rel="bookmark" class="title">中国网络游戏市场</a>
					<div>
						网游依旧风光.&lt;2011年度中国游戏产业调查报告&gt;显示,2011年中国游戏市场实际销售收入446.1亿元人民币,比2010年增长了34%. &quot;到哪儿找这样的好行业?年增长率30% ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEYKa3b.html" rel="bookmark" class="title">值得分享的轻量级Bootstrap Table表格插件&lowbar;javascript技巧</a>
					<div>
						基于Bootstrap的轻量级表格插件Bootstrap Table只需简单的配置,就可以拥有强大的支持固定表头.单/复选.排序.分页.搜索及自定义表头等功能,更好的提高开发效率和减少开发时间. 1. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqWJXGz.html" rel="bookmark" class="title">Android ExpandableListView长按事件的完美解决办法&lowbar;Android</a>
					<div>
						关于ExpandableListView长按事件处理,网上很多都是使用将上下文菜单注册到ExpandableListView上实现长按事件. 这样做弊端显而易见,不够灵活,不能分别对父项.子项.父项之 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3Z8wkz.html" rel="bookmark" class="title">js&sol;html光标定位的实现代码&lowbar;javascript技巧</a>
					<div>
						复制代码 代码如下: &lt;!DOCTYPE HTML PUBLIC &quot;-//W3C//DTD HTML 4.0 Transitional//EN&quot;&gt; &lt;HTML&g ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVdNknM.html" rel="bookmark" class="title">Oracle将NetBeans交给了Apache基金会</a>
					<div>
						NetBeans社区博客宣布,Oracle正提议将NetBeans平台和IDE的开发委托给Apache基金会,&quot;开放治理模型&quot;,并重申了对这个项目的承诺. NetBeans现在已经 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOWX0qz.html" rel="bookmark" class="title">sql2000各个版本区别总结第1&sol;3页&lowbar;MsSql</a>
					<div>
						SQL Server 联机帮助给出了详细说明. --&gt;目录 --&gt;SQL Server架构 --&gt;实施细则 --&gt;SQL Server 2000版本 SQL Server 20 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJePnVp.html" rel="bookmark" class="title">js笔记&mdash;&mdash;js里的null和undefined</a>
					<div>
						以下内容摘录自阮一峰的&lt;语法概述 -- JavaScript 标准参考教程(alpha)&gt;章节『5.null和undefined』,以做备忘. null与undefined都可以表示&qu ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.026 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
